#include <ESP8266WiFi.h>	// for WIFI
#include <time.h>			// for time(), localtime()
#include "I2CLiquidCrystal.h"

// Wi-Fi設定
#define WIFI_SSID		"aterm-e7797f-g"
#define WIFI_PASSWORD	"9b8bba19c87e7"

// NTP設定
#define TIMEZONE_JST	(3600 * 9)	// 日本標準時は、UTC（世界標準時）よりも９時間進んでいる。
#define DAYLIGHTOFFSET_JST	(0)		// 日本は、サマータイム（夏時間）はない。
#define NTP_SERVER1		"ntp.nict.jpntp.nict.jp"	// NTPサーバー
#define NTP_SERVER2		"ntp.jst.mfeed.ad.jp"		// NTPサーバー

// LCD設定
#define I2CADDR_LCD		(0x3E)	// AQM1602XAのI2Cアドレスは0x3E
I2CLiquidCrystal g_i2clcd(I2CADDR_LCD, 4, 5);	// i2c_addr, sda, scl

void setup()
{
	// Wi-Fiセットアップ
	// WiFiネットワーク接続
	WiFi.begin(WIFI_SSID, WIFI_PASSWORD);
	while (WiFi.status() != WL_CONNECTED)
	{
		delay(500);
	}

	// NTP同期
	configTime( TIMEZONE_JST, DAYLIGHTOFFSET_JST, NTP_SERVER1, NTP_SERVER2 );

	// LCDセットアップ
	g_i2clcd.begin();
	g_i2clcd.clear();
}

void loop()
{
	// 曜日文字列配列
	static const char *pszWDay[] = {"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};

	// 現在時刻の取得
	time_t timeNow = time(NULL);
	struct tm* tmNow = localtime(&timeNow);

	// 日付
	char szDate[32];
	sprintf( szDate, "%04d/%02d/%02d(%s)",
					tmNow->tm_year+1900,
					tmNow->tm_mon+1,
					tmNow->tm_mday,
					pszWDay[tmNow->tm_wday] );

	// 時刻
	char szTime[32];
	sprintf( szTime, "%02d:%02d:%02d",
					tmNow->tm_hour,
					tmNow->tm_min,
					tmNow->tm_sec );

	// LCD出力
	g_i2clcd.setCursor( 0, 0 );
	g_i2clcd.print(szDate);
	g_i2clcd.setCursor( 0, 1 );
	g_i2clcd.print(szTime);

	delay( 1000 );
}
